/*
 * main.c
 *
 *  Created on: 31 Dec 2013
 *      Author: krishnak
 */

#include "nrf_delay.h"
#include "nrf_gpio.h"
#include "nrf_esb.h"

#define PIPE_NUMBER 0 ///pipe 0
#define TX_PAYLOAD_LENGTH 10
static uint8_t my_tx_payload[] = { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0 }; ///< Payload to send to PRX.
//static uint8_t my_rx_payload[10]; ///< Placeholder for received ACK payloads from PRX.
int main(void) {

	// Setup port directions
	nrf_gpio_port_dir_set(2, NRF_GPIO_PORT_DIR_OUTPUT);

	// Initialise ESB
	nrf_esb_set_xosc_ctl(NRF_ESB_XOSC_CTL_AUTO);
	nrf_esb_init(NRF_ESB_MODE_PTX);
	nrf_esb_set_crc_length(NRF_ESB_CRC_LENGTH_2_BYTE);
	nrf_esb_set_datarate(NRF_ESB_DATARATE_2_MBPS);
	nrf_esb_set_retransmit_delay(600);
	nrf_esb_set_max_number_of_tx_attempts(5);

	nrf_esb_set_enabled_prx_pipes(0x03);
	nrf_esb_set_base_address_length(NRF_ESB_BASE_ADDRESS_LENGTH_4B);
	//private  final byte[] pipe0Address = { (byte) 0xC4,0x7B,0x4D,0x03,0x31};

	nrf_esb_set_address_prefix_byte(0, 0xC4);
	nrf_esb_set_base_address_0(0x31034d7b);  //31034d7b

	nrf_esb_set_channel(2);

	// Add packet into TX queue
	// NOTE: If you add just 1 pay load, for some reason the radio switches off
	// after sending the first packet, even though I add another packet in
	//	nrf_esb_tx_success - may be the radio switches off before it calls tx_success
	nrf_esb_add_packet_to_tx_fifo(PIPE_NUMBER, my_tx_payload, 10,
			NRF_ESB_PACKET_USE_ACK);
	nrf_esb_add_packet_to_tx_fifo(PIPE_NUMBER, my_tx_payload, 10,
			NRF_ESB_PACKET_USE_ACK);

	nrf_esb_enable();

	while (1) {

	}

}
// If an ACK was received, we send another packet.
void nrf_esb_tx_success(uint32_t tx_pipe, int32_t rssi) {
	//	nrf_gpio_port_write(2, 16);

	(void) nrf_esb_add_packet_to_tx_fifo(PIPE_NUMBER, my_tx_payload,
			TX_PAYLOAD_LENGTH, NRF_ESB_PACKET_USE_ACK);
}

// If the transmission failed, send a new packet.
void nrf_esb_tx_failed(uint32_t tx_pipe) {

	(void) nrf_esb_add_packet_to_tx_fifo(PIPE_NUMBER, my_tx_payload,
			TX_PAYLOAD_LENGTH, NRF_ESB_PACKET_USE_ACK);

}

void nrf_esb_rx_data_ready(uint32_t rx_pipe, int32_t rssi) {

	uint32_t my_rx_payload_length;
	// Pop packet and write first byte of the payload to the GPIO port.
	//(void) nrf_esb_fetch_packet_from_rx_fifo(PIPE_NUMBER, my_rx_payload,
	//	&my_rx_payload_length);

	// Flushing Rx fifo so that there is space for future transmits
	nrf_esb_flush_rx_fifo(PIPE_NUMBER);

}

void nrf_esb_disabled(void) {
}
